/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.documentos;

import danielcortes.xyz.data.ConnectionHolder;
import danielcortes.xyz.models.caja.Caja;
import danielcortes.xyz.models.caja.CajaDAO;
import danielcortes.xyz.models.caja.SQLiteCajaDAO;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public abstract class DocumentosDAO {
    private static final Logger LOGGER = Logger.getLogger(DocumentosDAO.class.getName());

    protected ConnectionHolder connectionHolder;

    public abstract List<Documentos> findAll();

    public abstract Documentos findById(int id);

    public abstract Documentos findByCaja(Caja caja);

    public abstract boolean insertDocumentos(Documentos documentos);

    public abstract boolean insertDefaultDocumentos(Documentos documentos);

    public abstract boolean updateDocumentos(Documentos documentos);

    public abstract boolean deleteDocumentos(Documentos documentos);

    public abstract int getTotalDocumentos(Caja caja);

    protected List<Documentos> documentosFromResultSet(ResultSet rs) throws SQLException {
        List<Documentos> documentosList = new ArrayList<>();
        while (rs.next()) {
            CajaDAO cajaDAO = new SQLiteCajaDAO();
            Caja caja = cajaDAO.findById(rs.getInt("caja_id"));

            Documentos documentos = new Documentos();
            documentos.setCaja(caja);
            documentos.setId(rs.getInt("id"));
            documentos.setCheques(rs.getInt("cheques"));
            documentos.setTarjetas(rs.getInt("tarjetas"));
            documentos.setRetiros(rs.getInt("retiros"));

            LOGGER.log(Level.FINER, "Se a creo: {0}", documentos);

            documentosList.add(documentos);

        }
        return documentosList;
    }
}
